/* faSize - print total size and total N count of FA file. */
#include "common.h"
#include "fa.h"
#include "dnautil.h"

void usage()
/* Print usage info and exit. */
{
errAbort("faSize - print total base count in fa files.\n"
	 "usage:\n"
	 "   faSize file(s).fa\n");
}


void faSize(char *faFiles[], int faCount)
/* faSize - print total size and total N count of FA files. */
{
char *fileName;
int i;
struct dnaSeq seq;
int fileCount = 0;
int seqCount = 0;
unsigned long baseCount = 0;
unsigned long nCount = 0;
FILE *f;

dnaUtilOpen();
for (i = 0; i<faCount; ++i)
    {
    fileName = faFiles[i];
    f = mustOpen(fileName, "r");
    ++fileCount;
    while (faFastReadNext(f, &seq.dna, &seq.size, &seq.name))
	{
	int j;
	++seqCount;
	for (j=0; j<seq.size; ++j)
	    {
	    DNA d = seq.dna[j];
	    if (d == 'n' || d == 'N')
		++nCount;
	    }
	baseCount += seq.size;
	}
    carefulClose(&f);
    }
printf("%lu bases including %lu N's in %d sequences in %d files\n",
    baseCount, nCount, seqCount, fileCount);
}

int main(int argc, char *argv[])
/* Process command line . */
{
if (argc < 2)
    usage();
faSize(argv+1, argc-1);
return 0;
}
